﻿//
// Copyright (c) 2015, MindFusion LLC - Bulgaria.
//

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Controls.Primitives;


namespace MindFusion.Scheduling.Wpf.Samples.CS.Highlighting
{
	/// <summary>
	/// Interaction logic for MainWindow.xaml
	/// </summary>
	public partial class MainWindow : Window
	{
		public MainWindow()
		{
			InitializeComponent();

			_contextMenu = new ContextMenu();
			
			for (int i = 0; i < 3; i++)
			{
				MenuItem a = new MenuItem();
				a.Header = "Action " + (i + 1).ToString();
				_contextMenu.Items.Add(a);
			}

			_contextMenu.Closed += new RoutedEventHandler(_contextMenu_Closed);
		}

		void _contextMenu_Closed(object sender, RoutedEventArgs e)
		{
			calendar.Selection.Reset();
		}

		void calendar_MouseDown(object sender, MouseButtonEventArgs e)
		{
			if (e.RightButton == MouseButtonState.Pressed && e.LeftButton == MouseButtonState.Released &&
				e.ClickCount == 1)
			{
				if (calendar.CurrentView == CalendarView.Timetable)
					calendar.Selection.Set(_clickedDate, _clickedDate.Add(calendar.TimetableSettings.CellTime));
				else
					calendar.Selection.Set(_clickedDate);

				if (!atCursor)
				{
					_contextMenu.PlacementTarget = (sender as UIElement);
					_contextMenu.PlacementRectangle = _clickedBounds;
					_contextMenu.Placement = PlacementMode.Bottom;
				}
				else
				{
					_contextMenu.PlacementTarget = (sender as UIElement);
					_contextMenu.PlacementRectangle = _clickedBounds;
					_contextMenu.Placement = PlacementMode.Mouse;
				}

				_contextMenu.IsOpen = true;
			}
		}

		void calendar_DateClick(object sender, ResourceDateEventArgs e)
		{
			if (e.RightButton == MouseButtonState.Pressed && e.LeftButton == MouseButtonState.Released &&
				e.Clicks == 1)
			{
				_clickedDate = e.Date;
				_clickedResource = e.Resource;
				_clickedBounds = e.Bounds;
			}
		}

		private void _menuSingleMonth_Click(object sender, RoutedEventArgs e)
		{
			calendar.CurrentView = CalendarView.SingleMonth;
		}

		private void _menuTimetable_Click(object sender, RoutedEventArgs e)
		{
			calendar.CurrentView = CalendarView.Timetable;
		}

		private void _menuList_Click(object sender, RoutedEventArgs e)
		{
			calendar.CurrentView = CalendarView.List;
		}

		private void _menuAtCursor_Click(object sender, RoutedEventArgs e)
		{
			atCursor = true;
		}

		private void _menuAtCellBorder_Click(object sender, RoutedEventArgs e)
		{
			atCursor = false;
		}

		private void _menuView_SubmenuOpened(object sender, RoutedEventArgs e)
		{
			_menuSingleMonth.IsChecked = (calendar.CurrentView == CalendarView.SingleMonth);
			_menuTimetable.IsChecked = (calendar.CurrentView == CalendarView.Timetable);
			_menuList.IsChecked = (calendar.CurrentView == CalendarView.List);
		}

		private void _menuPosition_SubmenuOpened(object sender, RoutedEventArgs e)
		{
			_menuAtCursor.IsChecked = atCursor;
			_menuAtCellBorder.IsChecked = !atCursor;
		}


		private ContextMenu _contextMenu;
		private bool atCursor = false;
		private DateTime _clickedDate = DateTime.MinValue;
		private Resource _clickedResource = null;
		private Rect _clickedBounds = Rect.Empty;
	}
}
